
----------------------------------
-- module independent variables --
----------------------------------
local addon, ns = ...
local C, L, I = ns.color, ns.L, ns.I


-----------------------------------------------------------
-- module own local variables and local cached functions --
-----------------------------------------------------------
local name = "Framenames" -- L["Framenames"]
local ldbName = name
local tt = nil
local string = string


-- ------------------------------------- --
-- register icon names and default files --
-- ------------------------------------- --
I[name] = {iconfile="Interface\\Addons\\"..addon.."\\media\\equip"}


---------------------------------------
-- module variables for registration --
---------------------------------------
ns.modules[name] = {
	desc = L["Broker to show names of frames under the mouse."],
	enabled = false,
	events = {},
	updateinterval = 0.1,
	config_defaults = nil,
	config_allowed = nil,
	config = nil
}


--------------------------
-- some local functions --
--------------------------


------------------------------------
-- module (BE internal) functions --
------------------------------------

ns.modules[name].init = function(self)
	ldbName = (Broker_EverythingDB.usePrefix and "BE.." or "")..name
	if self then
		local dataobj = self.obj or ns.LDB:GetDataObjectByName(ldbName)
		dataobj.text = L[name]
	end
end


--[[ ns.modules[name].onevent = function(self,event,msg) end ]]

ns.modules[name].onupdate = function(self)
	local dataobj = self.obj or ns.LDB:GetDataObjectByName(ldbName)
	local f = GetMouseFocus()
	if (not f) then
		if dataobj.text~=L["Unknown"] then
			dataobj.text = L["Unknown"]
		end
	else
		local F = (f:IsForbidden() and "[Forbidden Frame]") or (f:IsProtected() and InCombatLockdown() and "[Protected Frame]") or f:GetName()
		if F == nil and type(f.key)=="string" then -- LibQTip tooltips returns nil on GetName but f.key contains the current name
			F = f.key
		end
		if F == nil then F = "nil" end
		if dataobj.text ~= F then
			dataobj.text = F
		end
	end
end

--[[ ns.modules[name].optionspanel = function(panel) end ]]

--[[ ns.modules[name].onmousewheel = function(self,direction) end ]]

--[[ ns.modules[name].ontooltip = function(tt) end ]]


-------------------------------------------
-- module functions for LDB registration --
-------------------------------------------
ns.modules[name].onenter = function(self) end -- prevent displaying tt

--[[ ns.modules[name].onleave = function(self) end ]]

--[[ ns.modules[name].onclick = function(self,button) end ]]

--[[ ns.modules[name].ondblclick = function(self,button) end ]]

